/*===================================================================*
      Parameter Difinition
 *===================================================================*/	

/* Motor Parameter */					
#define		cMotor_R		0.566666667	// [Ohm] Winding resistance
#define		cMotor_Lq		0.316667	// [mH] q-axis inductance
#define		cMotor_Ld		0.316667	// [mH] d-axis inductance
#define		cMotor_E		0.02404		// [V] induced voltage
#define		cPole			8			// [Pole] Poles of the motor

/* PWM Parameter */	
#define		cIMCLK_FRQ		80.00		// [MHz] Base clock of PMD
#define		cPWMPRD			125			// [us] PWM fuency	
#define		cDEADTIME		1.4			// [us] Dead time

/* Hardwear Parameter */
#define		cA_MAX			10	 		// [A] Input current(Iabc) at ADC =0xFFF0(5V)
#define		cV_MAX			300 		// [V] Input voltage(Vdc) at ADC =0xFFF0(5V)

/* External specification */
#define		S_speed_act0		50.00 	// [Hz] Target speed of motor when SW2 =H
#define		S_speed_act1		100.00 	// [Hz] Target speed of motor when SW2 =L
#define		S_Iq_st_user_act	1		// [A] Start current (Iq)
#define		S_Id_st_user_act	1		// [A] Start current (Id)

/* Control Gain constant */						
#define		cPosition_Kp	15.00 		// [Hz/V]  Position estimation Proportinal gain (Kp)
#define		cPosition_Ki	0.08 		// [Hz/Vs] Position estimation Integral gain (Ki)
#define		cSpeed_Kp		0.01 		// [A/Hz]  Speed Control Proportinal gain
#define		cSpeed_Ki		0.1 		// [A/Hzs] Speed Control Integral gain
#define		cId_Kp			1	 		// [V/A]  d-axis current control Proportinal gain 4
#define		cId_Ki			80	 		// [V/As] d-axis current control Integral gain 2
#define		cIq_Kp			1 			// [V/A]  q-axis current control Proportinal gain 4
#define 	cIq_Ki			80	 		// [V/As] q-axis current control Integral gain 2

#define		cFcdUDLim		50 			// [Hz/s] Limitation of the increase value (Forced Stage)
#define		cStdUpLim		70 			// [Hz/s] Limitation of the increase value (Steady Stage)
#define		cStdDwLim		100 		// [Hz/s] Limitation of the decrease value (Steady Stage) 100
#define		cInitLen		0.5 			// [s] Time of Positioning Stage
#define		cGoUpDelayLen	0.1 		// [s] Change-up Delay time
#define		cHz_MAX			200.00 		// [Hz] Maximum speed of motor (Fixed point 0xFFFF)
#define		cHz_LIMIT		180.00 		// [Hz] Limitation speed of motor
#define		cHz_MIN			30.00 		// [Hz] Minimam speed of motor
										// When set cHz_MIN > S_speed_actx, not move Stage from Force
#define		cI_Error		.00 		// [A] The value of current error
#define		cId_Lim			4.00 		// [A] d-axis limitation current
#define		cIq_Lim			4.00 		// [A] q-axis limitation current
#define		cMAX_ST_I		8.00 		// [A] Maximum current at start
#define		cVdc_Lim		40.00 		// [V] Limitation of Vdc
#define		cCtrlPrd		(0.000001*cPWMPRD) // 0.000064 // [s] Control period of motor
#define		cEncPulseNum	2048		// Number of Encoder pulse
#define		cEncMultiple	4			// 

#define		cMainLoopPrd	0.001		// [s] Cycle time of MAIN control 
#define		cMainLoopTime	(cMainLoopPrd/(cPWMPRD *0.000001))
										// [LOOPTime] Cycle time of MAIN control

// Status for Debug
#define		F_VoltageControl	0		// 1:Voltage control only (No current control)
#define		cVd				0x0BB80000	// When F_VoltageControl==1, use cVd
#define		cVq				0x0A000000	// When F_VoltageControl==1, use cVq

#define		F_Fixed_Vdc		0			// 1:When Vdc is used from constant data
#define		cVdc			15000		// When cFixed_Vdc==1, use (cV_MAX * cVdc/32767)V

