/********************************************************
*														*
*	Setting of I/O Register								*
*														*
*********************************************************/

#include	"TMPM370.h"
#include	"initial.h"
#include	"ipdefine.h"
#include    "D_Para.h"
#include	"port_def.h"
#include	"m370_int.h"


void  B_User_Initialize()
{
}

/********************************************************
	Port difinition to [SMC] bord						*
*********************************************************/
void	init_PORT()
{
	/* PORT A */
	PA->DATA = init_PADT;
	PA->CR = init_PACR;
	PA->FR1 = init_PAFR1;
	PA->FR2 = init_PAFR2;
	PA->OD = init_PAOD;
	PA->PUP = init_PAPUP;
	PA->PDN = init_PAPDN;
	PA->IE = init_PAIE;

	/* PORT B */
	PB->DATA = init_PBDT;
	PB->CR = init_PBCR;
	PB->FR1 = init_PBFR1;
//	PBFR2 = init_PBFR2;
//	PB->OD = init_PBOD;			/* -100126 */
	PB->PUP = init_PBPUP;
	PB->PDN = init_PBPDN;
	PB->IE = init_PBIE;

	/* PORT C */
	PC->DATA = init_PCDT;
	PC->CR = init_PCCR;
	PC->FR1 = init_PCFR1;
//	PC->FR2 = init_PCFR2;
	PC->OD = init_PCOD;
	PC->PUP = init_PCPUP;
	PC->PDN = init_PCPDN;
	PC->IE = init_PCIE;

	/* PORT D */
	PD->DATA = init_PDDT;
	PD->CR = init_PDCR;
	PD->FR1 = init_PDFR1;
	PD->FR2 = init_PDFR2;
	PD->OD = init_PDOD;
	PD->PUP = init_PDPUP;
	PD->PDN = init_PDPDN;
	PD->IE = init_PDIE;

	/* PORT E */
	PE->DATA = init_PEDT;
	PE->CR = init_PECR;
	PE->FR1 = init_PEFR1;
	PE->FR2 = init_PEFR2;
	PE->OD = init_PEOD;
	PE->PUP = init_PEPUP;
	PE->PDN = init_PEPDN;
	PE->IE = init_PEIE;

	/* PORT F */
	PF->DATA = init_PFDT;
	PF->CR = init_PFCR;
	PF->FR1 = init_PFFR1;
	PF->FR2 = init_PFFR2;
	PF->FR3 = init_PFFR3;
	PF->OD = init_PFOD;
	PF->PUP = init_PFPUP;
//	PF->PDN = init_PFPDN;
	PF->IE = init_PFIE;

	/* PORT G */
	PG->DATA = init_PGDT;
	PG->CR = init_PGCR;
	PG->FR1 = init_PGFR1;
//	PG->FR2 = init_PGFR2;
	PG->OD = init_PGOD;
	PG->PUP = init_PGPUP;
	PG->PDN = init_PGPDN;
	PG->IE = init_PGIE;

	/* PORT H */
	PH->DATA = init_PHDT;
	PH->CR = init_PHCR;
	PH->FR1 = init_PHFR1;
//	PH->FR2 = init_PHFR2;
	PH->OD = init_PHOD;
	PH->PUP = init_PHPUP;
	PH->PDN = init_PHPDN;
	PH->IE = init_PHIE;

	/* PORT I */
	PI->DATA = init_PIDT;
	PI->CR = init_PICR;
//	PI->FR1 = init_PIFR1;
//	PI->FR2 = init_PIFR2;
	PI->OD = init_PIOD;
	PI->PUP = init_PIPUP;
	PI->PDN = init_PIPDN;
	PI->IE = init_PIIE;

	/* PORT J */
	PJ->DATA = init_PJDT;
	PJ->CR = init_PJCR;
	PJ->FR1 = init_PJFR1;
//	PJFR2 = init_PJFR2;
	PJ->OD = init_PJOD;
	PJ->PUP = init_PJPUP;
	PJ->PDN = init_PJPDN;
	PJ->IE = init_PJIE;

	/* PORT K */
	PK->DATA = init_PKDT;
	PK->CR = init_PKCR;
	PK->FR1 = init_PKFR1;
//	PKFR2 = init_PKFR2;
	PK->OD = init_PKOD;
	PK->PUP = init_PKPUP;
	PK->PDN = init_PKPDN;
	PK->IE = init_PKIE;

}
/* Clock "MAX" SET */
void    GEAR_TOP()
{
	VAR16	n;


	CG->PLLSEL = cPLLSEL_Init;		// PLL init & fosc
	for(n = 0; n < 200; n++);			// Wait......
	CG_OSCCR_OSCSEL = 1;			/* External */
	__DSB();

	for(n = 0; n < 200; n++);			// Wait......
	CG_OSCCR_PLLON = 1;				/* PLL start */
	__DSB();


	for(n = 0; n < 400; n++);			// Wait......
	CG->PLLSEL = cPLLSEL_fpll;		/* PLL clock serect fpll */


	__DSB();	// SYNC
}

/* Clock "HALF" set */
void    GEAR_DIV()
{
  	VAR16	n;
  
	CG->SYSCR = cSYSCR_HALF;		/* Clock speed set to 40MHz */
									/* Prescaler set maximam (fperiph/2) */

	CG->PLLSEL = cPLLSEL_Init;		// PLL init & fosc
	for(n = 0; n < 200; n++);		// Wait......
	CG_OSCCR_OSCSEL = 1;			/* External */
	__DSB();

	for(n = 0; n < 200; n++);		// Wait......
	CG_OSCCR_PLLON = 1;				/* PLL start */
	__DSB();


	for(n = 0; n < 400; n++);		// Wait......
	CG->PLLSEL = cPLLSEL_fpll;		/* PLL clock serect fpll */


	__DSB();	// SYNC
}

/* WDT Enable M370 */
void    init_WDTen()
{
	WD->CR  = 0x4e;			/* WDT Clear Code */
	WD->MOD = 0xB2;			/* Enable, 2^22/fsys, Reset generate */
	__DSB();
}

/* WDT Disable M370 */
void    init_WDTdis()
{
	WD->MOD &= 0x7f;			/* WDT Disable (bit7=0)*/
	WD->CR = 0xb1;				/* WDT Disable Code */
	__DSB();    				// SYNC
}

/* WDT counter clear M370 */
void    init_WDTclr()
{
	WD->CR = 0x4e;				/* WDT Clear Code */
	__DSB();    // SYNC
}

/* Encoder0 Initial set & Start M370 */
void    init_ENC0en()
{
	EN0->RELOAD = cEncPulseNum * cEncMultiple - 1;
								// Encoder puls set
	EN0->INT = 0x0000;			// No use CMP
	EN0->TNCR = cENTN_Init;		// 0x000000E0;
	__DSB();    // SYNC
}


/* ADC Inisial set & Start M370 */
void    init_ADCen()
{

/* PMD TRG Start mode set */

	// H_2ADC == 1	Use 1unit ADC for 3shunt
	// Convertion of 1 unit ADC at same time for 3 shunt
	// When TRGOUT==1, use 6 TRGs and 12 programs. need to set TRGSEL == Sector No.

	// ADA Program set
	ADA->PSEL0 = 0x80;			// TRG0:AProg0 at Sector0
	ADA->PSEL1 = 0x81;			// TRG1:AProg1 at Sector1
	ADA->PSEL2 = 0x82;			// TRG2:AProg2 at Sector2
	ADA->PSEL3 = 0x83;			// TRG3:AProg3 at Sector3
	ADA->PSEL4 = 0x84;			// TRG4:AProg4 at Sector4
	ADA->PSEL5 = 0x85;			// TRG5:AProg5 at Sector5

	ADB->PSEL0 = 0x00;			// TRG0:---
	ADB->PSEL1 = 0x00;			// TRG1:---
	ADB->PSEL2 = 0x00;			// TRG2:---
	ADB->PSEL3 = 0x00;			// TRG3:---
	ADB->PSEL4 = 0x00;			// TRG4:---
	ADB->PSEL5 = 0x00;			// TRG5:---

	ADA->PINTS0 = 0x01;			// End of all prog generate INTADA
	ADA->PINTS1 = 0x01;
	ADA->PINTS2 = 0x01;
	ADA->PINTS3 = 0x01;
	ADA->PINTS4 = 0x01;
	ADA->PINTS5 = 0x01;
	
								// bit7: Enable/Disable
								//  6~5: 00:non 01:U 10:V 11:W
								//    4: AD unit A:0 B:1
								//  3~0: AIN No.
//	ADA->PSET0 = 0x88A9EBCA;	// REG0:V-AINA10, REG1:W-AINA11, REG2:U-AINA9, REG3:Vdc-AINA8
	ADA->PSET00 = 0xCA;			// REG0:V-AINA10
	ADA->PSET01 = 0xEB;			// REG1:W-AINA11
	ADA->PSET02 = 0xA9;			// REG2:U-AINA9
	ADA->PSET03 = 0x88;			// REG3:Vdc-AINA8

//	ADA->PSET5 = 0x88A9EBCA;	// REG0:V-AINA10, REG1:W-AINA11, REG2:U-AINA9, REG3:Vdc-AINA8
	ADA->PSET50 = 0xCA;			// REG0:V-AINA10
	ADA->PSET51 = 0xEB;			// REG1:W-AINA11
	ADA->PSET52 = 0xA9;			// REG2:U-AINA9
	ADA->PSET53 = 0x88;			// REG3:Vdc-AINA8


//	ADA->PSET1 = 0x88CAA9EB;	// REG0:W-AINA11, REG1:U-AINA9,  REG2:V-AINA10, REG3: Vdc-AINA8
	ADA->PSET10 = 0xEB;			// REG0:W-AINA11
	ADA->PSET11 = 0xA9;			// REG1:U-AINA9
	ADA->PSET12 = 0xCA;			// REG2:V-AINA10
	ADA->PSET13 = 0x88;			// REG3:Vdc-AINA8

//	ADA->PSET2 = 0x88CAA9EB;	// REG0:W-AINA11, REG1:U-AINA9,  REG2:V-AINA10, REG3:Vdc-AINA8
	ADA->PSET20 = 0xEB;			// REG0:W-AINA11
	ADA->PSET21 = 0xA9;			// REG1:U-AINA9
	ADA->PSET22 = 0xCA;			// REG2:V-AINA10
	ADA->PSET23 = 0x88;			// REG3:Vdc-AINA8


//	ADA->PSET3 = 0x88EBCAA9;	// REG0:U-AINA9,  REG1:V-AINA10, REG2:W-AINA11, REG3:Vdc-AINA8
	ADA->PSET30 = 0xA9;			// REG0:U-AINA9
	ADA->PSET31 = 0xCA;			// REG1:V-AINA10
	ADA->PSET32 = 0xEB;			// REG2:W-AINA11
	ADA->PSET33 = 0x88;			// REG3:Vdc-AINA8

//	ADA->PSET4 = 0x88EBCAA9;	// REG0:U-AINA9,  REG1:V-AINA10, REG2:W-AINA11, REG3:Vdc-AINA8
	ADA->PSET40 = 0xA9;			// REG0:U-AINA9
	ADA->PSET41 = 0xCA;			// REG1:V-AINA10
	ADA->PSET42 = 0xEB;			// REG2:W-AINA11
	ADA->PSET43 = 0x88;			// REG3:Vdc-AINA8

	ADB->PSET00 = 0x00;			// REG0:---
	ADB->PSET01 = 0x00;			// REG0:---
	ADB->PSET02 = 0x00;			// REG0:---
	ADB->PSET03 = 0x00;			// REG0:---
	ADB->PSET10 = 0x00;			// REG0:---
	ADB->PSET11 = 0x00;			// REG0:---
	ADB->PSET12 = 0x00;			// REG0:---
	ADB->PSET13 = 0x00;			// REG0:---
	ADB->PSET20 = 0x00;			// REG0:---
	ADB->PSET21 = 0x00;			// REG0:---
	ADB->PSET22 = 0x00;			// REG0:---
	ADB->PSET23 = 0x00;			// REG0:---
	ADB->PSET30 = 0x00;			// REG0:---
	ADB->PSET31 = 0x00;			// REG0:---
	ADB->PSET32 = 0x00;			// REG0:---
	ADB->PSET33 = 0x00;			// REG0:---
	ADB->PSET40 = 0x00;			// REG0:---
	ADB->PSET41 = 0x00;			// REG0:---
	ADB->PSET42 = 0x00;			// REG0:---
	ADB->PSET43 = 0x00;			// REG0:---
	ADB->PSET50 = 0x00;			// REG0:---
	ADB->PSET51 = 0x00;			// REG0:---
	ADB->PSET52 = 0x00;			// REG0:---
	ADB->PSET53 = 0x00;			// REG0:---

	/* Common set */
	ADA->MOD0 = cADMOD0_Init;	// ADA REF ON
	ADB->MOD0 = cADMOD0_Init;	// ADB REF ON
	ADA_ENABLE;					// ADA Enable
	ADB_ENABLE;					// ADB Enable
	ADA->CLK = cADCLK_2us;		// ADA clock 2us@80MHz
	ADB->CLK = cADCLK_2us;		// ADB clock 2us@80MHz

	__DSB();    // SYNC
}

void    init_DAC()
{
/* Description : SIO Initiarise */
	SC1->EN = 1;					// SIO1 Enable
	SC1->CR = cSCCR_Ini;
	SC1->MOD0 = cSCMOD0_Ini;
	SC1->MOD1 = cSCMOD1_Ini;
	SC1->MOD2 = cSCMOD2_Ini;
	SC1->FCNF = cSCFCNF_Ini;
	SC1->BRCR = cSCBRCR_Ini;
	SC1->BRADD = cSCBRADD_Ini;
	SC1->BRCR = cSCBRCR_Ena;
	SC1->MOD1 = cSCMOD1_Ini + 0x10;		// Set bit4: TXE(Trans) Enable

/* DAC IC(AD2724) setting */
	PE->DATA &= 0xF7;					// PE3=L
	SC1->BUF = 0x10;					// DAC out 1~4 power on
	__DSB();    // SYNC

	while((SC1->MOD2 & 0x20)){}			// Wait to end of transmit
	SC1->BUF = 0x00;
	__DSB();    // SYNC
	while((SC1->MOD2 & 0x20)){}			// Wait to end of transmit
	SC1->BUF = 0x0F;
	__DSB();    // SYNC
	while((SC1->MOD2 & 0x20)){}			// Wait to end of transmit
	PE->DATA |= 0x08;					// PE3=H

	R_DebugOut_Counter = 13;			// 
	API_INT_PR_Set(EXT_INTTX1,0x0C);	/* Interruption level set */
	API_INT_SER_Set(EXT_INTTX1);		/* TX1 enable */


	__DSB();    // SYNC
}


/********************************************************************
	VE & PMD Initialize
********************************************************************/

void VE_Initialize(void)
{
/***********************VPMD0***************************************/

/* EMG set ------*/
	PMD0->EMGCR = cEMG_ENA;		// EMG Enable
	PMD0->EMGCR = cEMG_Release;	// EMG Release
	PMD0->EMGREL = 0x5A;		// Disable code
	PMD0->EMGREL = 0xA5;
	PMD0->EMGCR = cEMG_DIS;		// EMG Disable

/* OVV disable set ----*/
	PMD0->OVVCR = cOVV_DIS;

	PMD0->PORTMD = 0x3;			// UP/DOWN = PWM/~PWM at tool break
	PMD0->MDCR = cMDCR_INI;		// 
	PMD0->MODESEL = WBUF_VE;	// W-Buff from VE

	PMD0->MDPOT = cMDPOT_OFF;	// UP/DOWN act = L/L
	PMD0->MDOUT = cMDOUT_OFF;	// UP/DOWN = OFF/OFF
	PMD0->MDPRD = cPWMPeriod;	// PWM frequency
	PMD0->DTR = cDeadTime;		// Dead timewr set

	PMD0->MDEN = 0x1;			// PMD enable (Set after set MDOUT,MDPOT)

	PC->FR1 = PMD0_PCFR1;		// PMD0 output Enable
	PC->CR  = PMD0_PCFR1;		// PMD0 output Enable

	PMD0->TRGCMP0 = 0x0000;		// TRG position clear
	PMD0->TRGCMP1 = 0x0000;
	PMD0->TRGCMP2 = 0x0000;
	PMD0->TRGCMP3 = 0x0000;

	PMD0->TRGCR = cTRG_3SHUNT;	// Trigger is PWM peek
	PMD0->TRGMD = 0x02;			// TRG0 change to TRGx (x:Sector No)
	PMD0->TRGSEL = 0;			// TRG No = Sector = 0r


/***********************VE Control Register*************************/
	VE->EN  = 0x1;				// VE Enable
	VE->OUTCR0 = 0x0000;		// Output UP/DOWN = OFF/OFF

	VE->CMPU0 = 0x5550;			//ioCMPU0In	;
	VE->CMPV0 = 0x5550;			//ioCMPV0In	;
	VE->CMPW0 = 0x5550;			//ioCMPW0In	;

	VE->FMODE0 = 0x00;			// Use ADC-A unit
	VE->MODE0 = 0x0;			// Output, Zero current, OFF
	VE->TPWM0 = cHz_MAX*cCtrlPrd*0x10000;
	VE->MDPRD0 = cPWMPeriod;	// PWM frequency

	VE->TASKAPP = 0x0;			// VE start from output control
	VE->ACTSCH = 0x9;			// Schedule 9
	VE->REPTIME = 1;			// Repeat time =1time

	VE->TRGMODE	=	0x1;		// ioTRGMODEIn	;
	VE->ERRINTEN	=	0x0;	// ioERRINTENIn	;
	VE->COMPEND	=	0x0;		// ioCOMPENDIn	;

	VE->TMPREG0	=	0x0;		// Temporary register clear
	VE->TMPREG1	=	0x0;		//
	VE->TMPREG2	=	0x0;		//
	VE->TMPREG3	=	0x0;		//
	VE->TMPREG4	=	0x0;		//
	VE->TMPREG5	=	0x0;		//

/***********************VE Register for Channel 0*********************/
	VE->VDC0	=	0x0;		// clear
	VE->VD0		=	0x0;		// clear
	VE->VQ0		=	0x0;		// clear

	VE->MCTLF0	=	0x0;		//ioMCTLF0In	;
	VE->OMEGA0	=	0x0;		//0x7FFF;//ioOMEGA0In	;
	VE->THETA0	=	0x0;		//ioTHETA0In	;

	VE->IQREF0	=	0x0;		// Clear
	VE->CIDKI0	=	cId_Ki;		// from D_para
	VE->CIDKP0	=	cId_Kp;		// from D_para
	VE->CIQKI0	=	cIq_Ki;		// from D_para
	VE->CIQKP0	=	cIq_Kp;		// from D_para
	VE->VDIH0	=	0x0;		// Clear
	VE->VDILH0	=	0x0;		// Clear
	VE->VQIH0	=	0x0;		// Clear
	VE->VQILH0	=	0x0;		// Clear
	VE->FPWMCHG0 =	0x0;		// Clear
	VE->MINPLS0	=	0x0;		// Clear

	VE->COS0		=	0x0;	// Clear
	VE->SIN0		=	0x0;	// Clear
	VE->COSM0		=	0x0;	// Clear
	VE->SINM0		=	0x0;	// Clear
	VE->SECTOR0		=	0x0;	// Clear
	VE->SECTORM0	=	0x0;	// Clear
	VE->IAO0		=	0x8600;	// Initial
	VE->IBO0		=	0x8600;	// Initial
	VE->ICO0		=	0x8600;	// Initial
	VE->IAADC0		=	0x0;	// Clear
	VE->IBADC0		=	0x0;	// Clear
	VE->ICADC0		=	0x0;	// Clear
	VE->ID0			=	0x0;	// Clear
	VE->IQ0			=	0x0;	// Clear


/***********************VE Register for Channel 1*********************/
	VE->MCTLF1		=	ioMCTLF1In	;
	VE->MODE1		=	ioMODE1In	;
	VE->FMODE1		=	ioFMODE1In	;
	VE->TPWM1		=	ioTPWM1In	;
	VE->OMEGA1		=	ioOMEGA1In	;
	VE->THETA1		=	ioTHETA1In	;
	VE->IDREF1		=	ioIDREF1In	;
	VE->IQREF1		=	ioIQREF1In	;
	VE->VD1			=	ioVD1In	;
	VE->VQ1			=	ioVQ1In	;
	VE->CIDKI1		=	ioCIDKI1In	;
	VE->CIDKP1		=	ioCIDKP1In	;
	VE->CIQKI1		=	ioCIQKI1In	;
	VE->CIQKP1		=	ioCIQKP1In	;
	VE->VDIH1		=	ioVDIH1In	;
	VE->VDILH1		=	ioVDILH1In	;
	VE->VQIH1		=	ioVQIH1In	;
	VE->VQILH1		=	ioVQILH1In	;
	VE->FPWMCHG1	=	ioFPWMCHG1In	;
	VE->MDPRD1		=	ioVMDPRD1In	;
	VE->MINPLS1		=	ioMINPLS1In	;
	VE->TRGCRC1		=	ioTRGCRC1In	;
//	VE.IO_VDCL1	=	ioVDCL1In	;
	VE->COS1		=	ioCOS1In	;
	VE->SIN1		=	ioSIN1In	;
	VE->COSM1		=	ioCOSM1In	;
	VE->SINM1		=	ioSINM1In	;
	VE->SECTOR1		=	ioSECTOR1In	;
	VE->SECTORM1	=	ioSECTORM1In	;
	VE->IAO1		=	ioIAO1In	;
	VE->IBO1		=	ioIBO1In	;
	VE->ICO1		=	ioICO1In	;
	VE->IAADC1		=	ioIAADC1In	;
	VE->IBADC1		=	ioIBADC1In	;
	VE->ICADC1		=	ioICADC1In	;
	VE->VDC1		=	ioVDC1In	;
	VE->ID1			=	ioID1In	;
	VE->IQ1			=	ioIQ1In	;


/***********************VE Common Register*****************************/
//	VE->MMODE	=	0x0;		//ioMMODEIn	;
	VE->TADC	=	0x0;		//ioTADCIn	;
	VE->TRGCMP00	=	0x0;	//ioVTRGCMP00In	;
	VE->TRGCMP10	=	0x0;	//ioVTRGCMP10In	;
	VE->TRGSEL0	=	0x0;		//ioVTRGSEL0In	;
	VE->EMGRS0	=	0x0;		//ioEMGRS0In	;
	VE->CMPU1	=	0x0;		//ioVCMPU1In	;
	VE->CMPV1	=	0x0;		//ioVCMPV1In	;
	VE->CMPW1	=	0x0;		//ioVCMPW1In	;
	VE->OUTCR1	=	0x0;		//ioOUTCR1In	;
	VE->TRGCMP01	=	0x0;	//ioVTRGCMP01In	;
	VE->TRGCMP11	=	0x0;	//ioVTRGCMP11In	;
	VE->TRGSEL1	=	0x0;		//ioVTRGSEL1In	;
	VE->EMGRS1	=	0x0;		//ioEMGRS1In	;

	API_INT_PR_Set(EXT_INTVCNA,0x0C);	/* Interruption level set */
	API_INT_SER_Set(EXT_INTVCNA);		/* INTVCNA enable */

}
