#ifndef _MAIN_H
#define _MAIN_H

#undef EXTERN
#ifdef DEFINE_APP
#define EXTERN
#else
#define EXTERN  extern
#endif

/*==================================================================*
	Define of Variable data
 *==================================================================*/
	VAR16					M_Main_Counter;			// Main loop counter
	VAR16					R_DebugOut_Counter;		// Counter for DAC data Output

	T_ComUser				S_com_user;				// User Command
	T_ComUser				S_com_user_1;			// Before User Command */

	Stage					S_stage;
	HALF					R_state;				// Emergency State

	T_32Q31					S_sp_ud_lim_f_user;		// Limitation of the increase value (Forced Stage)
	T_32Q31					S_sp_up_lim_s_user;		// Limitation of the increase value (Steady Stage)
	T_32Q31					S_sp_dn_lim_s_user;		// Limitation of the decrease value (Steady Stage)

	UVAR16					S_Initp_time_user;		// Time of Positioning Stage
	UVAR16					S_go_up_time_user;		// Time of Change-up Stage

	T_32Q31					R_omega_com;		/* [Hz/maxHz] Command of Motor omega (electrical angle)  */
	T_16Q15					R_theta_com;		/* [---] Command of motor theta */

	T_32Q31					R_Id_com;			/* [A/maxA] d-axis current command */
	T_32Q31					R_Iq_com;			/* [A/maxA] q-axis current command */

	T_16Q15					R_Vd_com;			/* [V/maxV] d-axis voltage command */
	T_16Q15					R_Vq_com;			/* [V/maxV] q-axis voltage command */

	T_16Q15					R_Ia;				/* [A/maxA] a phase current */
	T_16Q15					R_Ib;				/* [A/maxA] b phase current */
	T_16Q15					R_Ic;				/* [A/maxA] c phase current */

	T_16Q15					R_Id;				/* [A/maxA] d-axis current */
	T_16Q15					R_Iq;				/* [A/maxA] q-axis current */

	T_16Q15					R_Id_ref;			/* [A/maxA] Referense of d-axis current */
	T_16Q15					R_Iq_ref;			/* [A/maxA] Referense of q-axis current */
	T_32Q31					R_Iq_ref_I;			/* [A/maxA] q-axis current command (Integral) */

	T_16Q15					R_Id_dev;			/* [A/maxA] Deviation value of d-axis current */
	T_16Q15					R_Iq_dev;			/* [A/maxA] Deviation value of q-axis current */

	T_16Q15					R_Iao;				/* [---] a phase zero current */
	T_16Q15					R_Ibo;				/* [---] b phase zero current */
	T_16Q15					R_Ico;				/* [---] c phase zero current */

	T_16Q15					R_Ialpha;			/* [A/maxA] Alfa phase current */
	T_16Q15					R_Ibeta;			/* [A/maxA] Beta phase current */

	T_16Q15					R_Ia_adc;			/* [---] a phase ADC */
	T_16Q15					R_Ib_adc;			/* [---] b phase ADC */
	T_16Q15					R_Ic_adc;			/* [---] c phase ADC */

	T_32Q31					R_Vd;				/* [V/maxV] d-axis Voltage */
	T_32Q31					R_Vq;				/* [V/maxV] q-axis Voltage */

	T_32Q31					R_Vd_I;				/* [V/maxV] d-axis Voltage(Integral) */
	T_32Q31					R_Vq_I;				/* [V/maxV] q-axis Voltage(Integral) */
	T_32Q31					R_Vd_1;				/* [V/maxV] d-axis Voltage(Saved) */
	T_32Q31					R_Vq_1;				/* [V/maxV] q-axis Voltage(Saved) */

	T_16Q15					R_Ed;				/* [V/maxV] d-axis induced voltage */
	T_16Q15					R_Eq;				/* [V/maxV] q-axis induced voltage */

	T_16Q15					R_Vdc_adc;			/* [---] DC voltage (ADC) */
	T_16Q15					R_Vdc;				/* [V/maxV] DC voltage */

	T_16Q15					R_Valpha;			/* [V/maxV] Alfa phase voltage */
	T_16Q15					R_Vbeta;			/* [V/maxV] Beta phase voltage */

	VAR16					R_Va_dt;			/* [---] a phase PWM duty */
	VAR16					R_Vb_dt;			/* [---] b phase PWM duty */
	VAR16					R_Vc_dt;			/* [---] c phase PWM duty */

	T_32Q31					R_omega;			/* [Hz/maxHz]  Omega(speed): Electrical angle   */
	T_32Q31					R_omega_I;			/* [Hz/maxHz]                Integration value  */
	T_16Q15					R_omega_dev;		/* [Hz/maxHz]                Saved              */

	T_32Q31					R_theta;			/* [---] Electrical angle */

	UVAR16					R_Sector;			/* Sector */

	UVAR16					R_Icont_Counter; 	/* Interruption counter */

	VAR16					S_lambda_user;		/* [deg/360] Lambda of command */

	UVAR16					S_stage_counter;	/* Stage counter */

	T_16Q15					S_Id_st_user;		/* [A/maxA] d-axis current command at start */
	T_16Q15					S_Iq_st_user;		/* [A/maxA] q-axis current command at start */
	T_16Q15					S_Id_com_user;		/* [A/maxA] d-axis current command */
	T_16Q15					S_Iq_com_user;		/* [A/maxA] q-axis current command */

	T_32Q31					S_omega_user;		/* [Hz/maxHz] OMEGA command */

	UVAR8					SG_SW_data[4];			/* SW 1~4 input data & Bafa */
	UVAR8					LED_data[4];		/* 0,1:motor1  2,3:motor2 */
	UVAR16					DAC_data[4];		/* */
	UVAR16					STOP_0DETECT;	
	UVAR16					ITR_STAGE;
	UVAR16					initVE;	
	UVAR32 					sel_timer;

/*===================================================================*
      Proto Type Definition
 *===================================================================*/
	short	E_Sine(short theta);
	short	E_Cosine(short theta);
EXTERN void	VE_Initialize();
EXTERN void	main_loop();
EXTERN void	B_User_Control(void);
EXTERN void	C_Control_Ref_Model(void);
EXTERN void	C_Common(void);
EXTERN void	C_Stage_Stop(void);
EXTERN void	C_Stage_Emergency(void);
EXTERN void	C_Stage_Initposition(void);
EXTERN void	C_Stage_Force(void);
EXTERN void	C_Stage_Change_up(void);
EXTERN void	C_Stage_Steady_A(void);
EXTERN void C_SG_SW_Input();
EXTERN void	C_TOG_SW_Input();
EXTERN void	C_LED_Output();
EXTERN void	B_User_Ram_Output(void);
EXTERN VAR32 C_command_limit_sub(VAR32 now,VAR32 target,VAR32 lim_up,VAR32 lim_down);


#undef EXTERN
#endif

